zoukankan      html  css  js  c++  java
  • luogu P3119 [USACO15JAN]草鉴定Grass Cownoisseur

    题目描述

    In an effort to better manage the grazing patterns of his cows, Farmer John has installed one-way cow paths all over his farm. The farm consists of N fields, conveniently numbered 1..N, with each one-way cow path connecting a pair of fields. For example, if a path connects from field X to field Y, then cows are allowed to travel from X to Y but not from Y to X.

    Bessie the cow, as we all know, enjoys eating grass from as many fields as possible. She always starts in field 1 at the beginning of the day and visits a sequence of fields, returning to field 1 at the end of the day. She tries to maximize the number of distinct fields along her route, since she gets to eat the grass in each one (if she visits a field multiple times, she only eats the grass there once).

    As one might imagine, Bessie is not particularly happy about the one-way restriction on FJ's paths, since this will likely reduce the number of distinct fields she can possibly visit along her daily route. She wonders how much grass she will be able to eat if she breaks the rules and follows up to one path in the wrong direction. Please compute the maximum number of distinct fields she can visit along a route starting and ending at field 1, where she can follow up to one path along the route in the wrong direction. Bessie can only travel backwards at most once in her journey. In particular, she cannot even take the same path backwards twice.

    约翰有n块草场,编号1到n,这些草场由若干条单行道相连。奶牛贝西是美味牧草的鉴赏家,她想到达尽可能多的草场去品尝牧草。

    贝西总是从1号草场出发,最后回到1号草场。她想经过尽可能多的草场,贝西在通一个草场只吃一次草,所以一个草场可以经过多次。因为草场是单行道连接,这给贝西的品鉴工作带来了很大的不便,贝西想偷偷逆向行走一次,但最多只能有一次逆行。问,贝西最多能吃到多少个草场的牧草。

    输入输出格式

    输入格式:

    INPUT: (file grass.in)

    The first line of input contains N and M, giving the number of fields and the number of one-way paths (1 <= N, M <= 100,000).

    The following M lines each describe a one-way cow path. Each line contains two distinct field numbers X and Y, corresponding to a cow path from X to Y. The same cow path will never appear more than once.

    输出格式:

    OUTPUT: (file grass.out)

    A single line indicating the maximum number of distinct fields Bessie

    can visit along a route starting and ending at field 1, given that she can

    follow at most one path along this route in the wrong direction.

    输入输出样例

    输入样例#1: 复制
    7 10 
    1 2 
    3 1 
    2 5 
    2 4 
    3 7 
    3 5 
    3 6 
    6 5 
    7 2 
    4 7 
    
    
    输出样例#1: 复制
    6 
    

    说明

    SOLUTION NOTES:

    Here is an ASCII drawing of the sample input:

    v---3-->6

    7 | |

    ^ v |

    | 1 | | | v | v 5

    4<--2---^

    Bessie can visit pastures 1, 2, 4, 7, 2, 5, 3, 1 by traveling

    backwards on the path between 5 and 3. When she arrives at 3 she

    cannot reach 6 without following another backwards path.

    1A爽,缩点后变成一棵树,spfa处理出树上每个点到1所在点的最长路,然后枚举连向点1和点1连向的点之间的边,答案就是这两个点最长路的和

    #include<cstdio>
    #include<cstring>
    #include<algorithm>
    using namespace std;
    const int maxn = 100007;
    inline int read() {
        int x=0,f=1;
        char c=getchar();
        while(c<'0'||c>'9') {
            if(c=='-')f=-1;
            c=getchar();
        }
        while(c<='9'&&c>='0') {
            x=x*10+c-'0';
            c=getchar();
        }
        return x*f;
    }
    int n,m;
    struct node{
        int v,next;
    }edge[maxn],E1[maxn],E2[maxn];
    int head[maxn],H1[maxn],H2[maxn],num,N1,N2;
    void add_edge(int x,int y) {
        edge[++num].v=y;edge[num].next=head[x];head[x]=num;
    }
    void A1(int x,int y) {
        E1[++N1].v=y;E1[N1].next=H1[x];H1[x]=N1;
    }
    void A2(int x,int y){
        E2[++N2].v=y;E2[N2].next=H2[x];H2[x]=N2;
    }
    int dfn[maxn],low[maxn],tn=0,stack[maxn],color[maxn],color_cnt;
    int top=0,cnt[maxn];bool vis[maxn];
    void tarjan(int x) {
        dfn[x]=low[x]=++tn;stack[++top]=x,vis[x]=1;
        for(int i=head[x];i;i=edge[i].next) {
            int v=edge[i].v;
            if(!dfn[v]) {
                tarjan(v);
                low[x]=min(low[x],low[v]);
            }
            else if(vis[v]) low[x]=min(low[x],dfn[v]);
        }
        if(dfn[x]==low[x]) {
            ++color_cnt;
            while(stack[top]!=x) {
                vis[stack[top]]=0;
                color[stack[top]]=color_cnt;
                top--;
                cnt[color_cnt]++;
            }
            cnt[color_cnt]++;
            color[x]=color_cnt;vis[x]=0;top--;
        }
    }
    int dis1[maxn],dis2[maxn];
    int que[maxn*4];
    bool can[maxn],can2[maxn];
    void topo1(int S) {
        int h=1,t=1;
        que[1]=S;
        dis1[S]=cnt[S];
        memset(vis,0,sizeof vis);
        vis[S]=1;can[S]=1;
        while(h<=t) {
            int u=que[h++];
            for(int i=H1[u];i;i=E1[i].next) {
                int v=E1[i].v;can[v]=1;
                if(dis1[v]<dis1[u]+cnt[v]) {
                    dis1[v]=max(dis1[v],dis1[u]+cnt[v]);
                    if(!vis[v])que[++t]=v,vis[v]=1;
                }
            }
            vis[u]=0;
        }
    }
    void topo2(int S) {
        int h=1,t=1;
        que[1]=S;
        dis2[S]=cnt[S];    
        memset(vis,0,sizeof vis);
        vis[S]=1;can2[S]=1;
        while(h<=t) {
            int u=que[h++];
            for(int i=H2[u];i;i=E2[i].next) {
                int v=E2[i].v;can2[v]=1;
                if(dis2[v]<dis2[u]+cnt[v]) {
                    dis2[v]=max(dis2[v],dis2[u]+cnt[v]);
                    if(!vis[v])que[++t]=v,vis[v]=1;
                }
            }
            vis[u]=0;
        }
    }
    int main() {
        n=read(),m=read();
        for(int a,b,i=1;i<=m;++i) {
            a=read(),b=read();
            add_edge(a,b);
        }
        for(int i=1;i<=n;++i) 
            if(!dfn[i])tarjan(i);
        int S=color[1];
        for(int i=1;i<=n;++i) {
            for(int j=head[i];j;j=edge[j].next) {
                int v=edge[j].v;
                if(color[v]!=color[i]){
                    A1(color[i],color[v]);
                    A2(color[v],color[i]);
                }
            }
        }
        topo1(color[1]);
        topo2(color[1]);
        int ans=0;
        for(int i=1;i<=color_cnt;++i) {
            for(int j=H1[i];j;j=E1[j].next) {
                int v=E1[j].v;
                if(can2[i]&&can[v]) {
                    ans=max(ans,dis2[i]+dis1[v]-cnt[color[1]]);
                }
            }
        }
        printf("%d
    ",ans);
        return 0;
    }
  • 相关阅读:
    蓝桥杯基础练习 杨辉三角形
    蓝桥杯基础练习 回文数 特殊的数字
    普及图论三题 P1807 P1113 P 4017
    P3916 图的遍历
    [转载][总结]图论入门:建图,DFS,BFS,拓扑排序
    如何转载博客园的文章
    P1892 [BOI2003]团伙
    P1621 集合
    [模板]线性筛素数(欧拉筛)
    P5076 普通二叉树(简化版)
  • 原文地址:https://www.cnblogs.com/sssy/p/7898955.html
Copyright © 2011-2022 走看看